<template>
  <div class="form">
    <h2>Covid 19 Stats</h2>
    <div class="search">
      <input placeholder="Country" v-model="country">&nbsp;
      <button v-on:click='search'>Search</button>
    </div>
    <div class="result" v-if="result">
      <div v-if="Array.isArray(result)">
        <table>
          <tr>
            <th>Country</th>
            <th>Confirmed</th>
            <th>Deaths</th>
            <th>Recovered</th>
            <th>Active</th>
            <th>Date</th>
          </tr>
          <tr v-for="item in result" v-bind:key="item.ID">
            <td>{{item.Country}}</td>
            <td>{{item.TotalConfirmed}}</td>
            <td>{{item.TotalDeaths}}</td>
            <td>{{item.TotalRecovered}}</td>
            <td>{{item.TotalConfirmed - item.TotalDeaths - item.TotalRecovered}}</td>
            <td>{{item.Date}}</td>
          </tr>
        </table>
      </div>
      <div v-else>
        <table>
          <tr>
            <th>Country</th>
            <th>Confirmed</th>
            <th>Deaths</th>
            <th>Recovered</th>
            <th>Active</th>
            <th>Date</th>
          </tr>
          <tr>
            <td>{{result.Country}}</td>
            <td>{{result.Confirmed}}</td>
            <td>{{result.Deaths}}</td>
            <td>{{result.Recovered}}</td>
            <td>{{result.Active}}</td>
            <td>{{result.Date}}</td>
          </tr>
        </table>
      </div>
    </div>
    <div class="error" v-if="error">{{error}}</div>
  </div>
</template>

<script>
import axios from 'axios';
export default {
  name: 'Covid',
  props: {

  },
  data () {
    return {
      result: null,
      error: null,
      country: null
    }
  },
  mounted() {
    axios
      .get('https://api.covid19api.com/summary')
      .then(response => {this.result = response.data.Countries; this.error = null;})
      .catch(error => {this.error = error; this.result = null;});
  },
  methods: {
    async search() {
      if (this.country) {
        let url = 'https://api.covid19api.com/country/' + this.country;
        await axios
          .get(url)
          .then(response => {this.result = response.data.slice(-1).pop(); this.error = null;})
          .catch(error => {this.error = error; this.result = null;});
      }
    }
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
  .form {
    padding: 40px;
  }
  button {
    background: #4CAF50;
    border: none;
    color: #fff;
    font-weight: bold;
    padding: 2px 5px 2px 5px;
  }

  button:hover {
    background: #000;
  }

  .error {
    color: crimson;
  }

  .result {
    margin-top: 25px;
  }

  table {
    font-family: Arial, Helvetica, sans-serif;
    border-collapse: collapse;
    width: 100%;
  }

  table td, table th {
    border: 1px solid #ddd;
    padding: 8px;
  }

  table tr:nth-child(even){background-color: #f2f2f2;}
  table tr:hover {background-color: #ddd;}

  table th {
    text-align: center;
    padding-top: 12px;
    padding-bottom: 12px;
    background-color: #4CAF50;
    color: white;
  }
</style>
